package nl.nikhef.tools.xml;


/**
 * Abstract base class for XOLProxy instances.
 * 
 * @author vincentb
 *
 * @param <T>	The type which is instantiated.
 */
public abstract class XOLProxyBase<T> implements XOLProxy<T> 
{

	
	private XOLProxy<?> _parent;
	private XOL _xol;
	
	
	@Override
	public boolean setAttribute(String name, String obj) {
		return false;
	}
	
	@Override
	public void setXOL(XOL xol) {
		if (_xol != null) throw new RuntimeException("XOL was already assigned!");
		_xol = xol;
	}
	
	public XOL getXol() {
		return _xol;
	}

	@Override
	public void addChild(XOLProxy<?> obj) {
	}

	@Override
	public T getInstance() {
		return null;
	}

	@Override
	public void setParent(XOLProxy<?> obj) {
		_parent = obj;
	}
	
	public <P extends XOLProxy<?>> P getParentAs(Class<P> clazz) {
		return clazz.cast(_parent);
	}

	@Override
	public boolean setContent(String data) {
		return false;
	}	
	
	@Override
	public void complete() {
	}
}
